#!/usr/bin/perl


#*************************** 設定項目 ********************************************

$pd="admin";			#管理パスワード(英数8字以内)※必ず変更すること

$opnum=5;			#オプションの入力数(S、L、M、・・・などの入力数)
$option=2;			#オプションの種類(サイズ、カラーなど)の数 2以内にすること

$logfile="log/goods.log";	#ログ
$jslog="../goods.js";		#ログ


#----------以下は変更の必要なし-------------------

$lockfile='log/lock';		#ロックファイル

@kigou1=('①','②','③','④','⑤','⑥','⑦','⑧','⑨','⑩');
@kigou2=('Ⅰ','Ⅱ','Ⅲ','Ⅳ','Ⅴ','Ⅵ','Ⅶ','Ⅷ','Ⅸ','Ⅹ');

$skin='tag.html';

$f_size="10pt";			#文字のサイズ(管理画面)
$l_color="#0000ff";		#リンク色(管理画面)
$b_color="#ffffff";		#背景色(管理画面)
$t_color="#000000";		#文字色(管理画面)

#**************************** 設定はここまで **************************************

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>50000){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}
if($buff){
	&decode;
}

sub decode{
my($name,$value,$pair,@pairs,$o,$d,$n);
@pairs=split(/&/,$buff);
foreach $pair (@pairs){
	($name,$value)=split(/=/,$pair);
	$value=~tr/+/ /;
	$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
	$value=~s/&/＆/g;
	$value=~s/</＜/g;
	$value=~s/>/＞/g;
	$value=~s/"/”/g;
	$value=~s/'/’/g;
	$value=~s/,//g;
	$value=~s/\x0D\x0A//g;
	$value=~s/\x0D//g;
	$value=~s/\x0A//g;
	if($name=~/^op/){
		($o,$d)=split(/_/,$name);
		push(@{$OPT{$o}},$value);
	}
	elsif($name=~/^ost/){
		$value=~s/://g;
		push @OPST,$value;
	}
	elsif($name=~/order_/){
		($d,$n)=split(/_/,$name);
		$ORDER{$n}=$value;
	}
	$FORM{$name}=$value;
}
}

if($FORM{'mode'}){
	&check($FORM{'pass'});
}

if($FORM{'mode'} eq "form"){
	&form;
}
elsif($FORM{'mode'} eq "regist"){
	&regist;
}
elsif($FORM{'mode'} eq "enter"){
	&enter;
}
elsif($FORM{'mode'} eq "del"){
	&del;
}
elsif($FORM{'mode'} eq "edit"){
	&form('edit');
}
elsif($FORM{'mode'} eq "editregist"){
	&editregist;
}
elsif($FORM{'mode'} eq "position"){
	&position;
}
elsif($FORM{'mode'} eq "tag"){
	&tag;
}
elsif($FORM{'mode'} eq "maketag"){
	&maketag;
}
elsif($FORM{'mode'} eq "preview"){
	&preview;
}
else{
	&ent;
}

sub ent{
&header;
print <<EOM;
<body>
<div id="login">
<form action="$script" method="POST">
<input type="hidden" name="mode" value="enter">
<p>※管理用パスワードを入力してください。</p>
<input type="password" name="pass" maxlength="8" size="8"> <input type="submit" value="管理用">
</form>
</div>
</body>
</html>
EOM
exit;

}



sub check{

if($_[0] ne $pd){
	&error("パスワードが違います");
}

}

sub position{
my(@keys,@order,@all,$i,$flag,@otmp,@tmp,$n,$j);


@keys=keys %ORDER;
@keys=sort{$a<=>$b}@keys;

foreach(@keys){
	push @order,$ORDER{$_};
}

unless(open(FILE,$logfile)){
	&error("$logfileが開けません。");
}
@all=<FILE>;
close FILE;


for($i=1;$i<=@all;$i++){
	$flag=0;
	foreach(@order){
		if($i == $_){
			$flag=1;
			last;
		}
	}
	if(!$flag){
		push @otmp,$i;
	}
}
$j=0;
$n=scalar(@all);
for($i=0;$i<$n;$i++){
	if($order[$i]){
		push @tmp,$order[$i];
	}
	else{
		push @tmp,$otmp[$j];
		$j++;
	}
}

@all=@all[sort {$tmp[$a] <=> $tmp[$b]} 0 .. $#tmp];

unless(open(FILE,">$logfile")){
	&error("$logfileに書き込みできません。パーミッションを確認してください。");
}
print FILE @all;
close FILE;

&enter;

}

sub form{
my($act,$msg,$tag,$flag);
my($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst);
my(@op,$i,$t,$o_name,$l,%OPT,$mode,$midasi,$tagline,$j);
my($c1,$c2,$n,$sa,$k,$q,$g,$col,$m);


$act=$_[0];
$msg=$_[1];
$tag=$_[2];


if($act eq "edit"){
	if($FORM{'editnum'} eq ""){
		&error("チェックを入れてください。","edit");
	}
	
	unless(open(FILE,$logfile)){
		&error("$logfileが開けません。");
	}
	$flag=0;
	while(<FILE>){
	($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst)=split(/,/,$_);
		if($no eq $FORM{'editnum'}){
			$flag=1;
			last;
		}
	}
	
	close FILE;
	
	if(!$flag){
		&error("$FORM{'editnum'}のデータがありません。");
	}
	
	if($op){
		$op.="<>d";
		@op=split(/<>/,$op);
		pop @op;
		$i=1;
		foreach $l(@op){
			$t="op$i";
			$o_name="";
			if($l=~/\//){
				($o_name,$l)=split(/\//,$l);
			}
			$O_NAME{$t}=$o_name;
			$l.=":d";
			@{$OPT{$t}}=split(/:/,$l);
			pop @{$OPT{$t}};
			$i++;
		}
	}
	
	if($opst){
		$opst.=":d";
		@opst=split(/:/,$opst);
		pop @opst;
	}

	$mode="editregist";
	$midasi="商品の編集";
	
	
	$FORM{'no'}=$no;
	$FORM{'name'}=$name;
	$FORM{'price'}=$price;
	$FORM{'image'}=$image;
	$FORM{'weight'}=$weight;
	$FORM{'postage'}=$postage;
	$FORM{'pack'}=$pack;
	$FORM{'page'}=$page;
	$FORM{'amount'}=$amount;
	$FORM{'stock'}=$stock;
	
	$tag=&maketag;
}
else{
	$mode="regist";
	$midasi="新規登録";
}

&header;

print <<EOM;
<body>
<div id="menu2"><a href="javascript:void(0)" onclick="document.fomove_enter.submit();" class="navi">トップ</a> ＞ $midasi</div>
<div id="cont">
	<div id="left">
		<p id="midasi2">$midasi</p>
		<div>$msg</div>
		<div>
			フォームに入力して「登録」ボタンを押してください。<br>
			「タグ生成」にチェックをいれていると右側にタグが生成されます。<br>
			「在庫数」またはオプションの「在庫数」に入力があると自動的にgoods.jsに記録されて、在庫管理されるようになります。<br>
			在庫管理だけ必要なときは、「商品番号」と「商品名」と「在庫数」だけ入力すればいいです。<br>
			<font color="#cc0000">＊</font>は入力必須です。
		</div>

<form name="fo" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="mode" value="$mode">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="editnum" value="$FORM{'editnum'}">
<table width="520" cellpadding="2" border="0">
<tr>
<td width="120">商品番号 <font color="#cc0000">＊</font></td><td width="400"><input type="text" name="no" value="$no"></td>
</tr>
<tr>
<td>商品名 <font color="#cc0000">＊</font></td><td><input type="text" name="name" size="40" value="$name"></td>
</tr>
<tr>
<td>在庫数</td><td><input type="text" name="stock" size="4" value="$stock"></td>
</tr>
<tr>
<td>価格</td><td><input type="text" name="price" value="$price"></td>
</tr>

<tr>
<td>画像のURL</td><td><input type="text" name="image" size="40" value="$image"></td>
</tr>
<tr>
<td>送料</td><td><input type="text" name="postage" value="$postage"></td>
</tr>
<tr>
<td>重量</td><td><input type="text" name="weight" size="4" value="$weight"></td>
</tr>
<tr>
<td>パックサイズ</td><td><input type="text" name="pack" size="4" value="$pack"></td>
</tr>
<tr>
<td>商品ページのURL</td><td><input type="text" name="page" value="$page"></td>
</tr>
<tr>
<td>個数の最大選択値</td><td><input type="text" name="amount" size="4" value="$amount">(例) 5</td>
</tr>
<tr>
<td valign="top">オプション</td>
<td>
EOM

if($option > 2){
	$option=2;
}
$tagline="";
if($option == 1){
	$j=1;
	$t="op".$j;
	print "オプション名 <input type=\"text\" name=\"o_name${j}\" size=\"12\" value=\"$O_NAME{$t}\"> (\"サイズ\"\"カラー\"など 未入力でもOK)<br>\n";
	if($act eq "edit"){
		$tagline.="<input type=\"hidden\" name=\"o_name${j}\" value=\"$O_NAME{$t}\">\n";
	}
	print "<table border=0><tr><td>\n";
	print "[値]<br>\n";
	if($opnum > 0){
		for($i=0;$i<$opnum;$i++){
			$k=$i+1;
			print qq($k:<input type="text" name="op${j}_value${k}" size="12" value="${$OPT{$t}}[$i]"><br>\n);
			if($act eq "edit"){
				$tagline.="<input type=\"hidden\" name=\"op${j}_value${k}\" value=\"${$OPT{$t}}[$i]\">\n";
			}
		}
	}
	print "</td>\n";
	print "<td>\n";
	print "[在庫数]<br>\n";
	if($opnum > 0){
		for($i=0;$i<$opnum;$i++){
			$k=$i+1;
			print qq($k:<input type="text" name="ost${k}" size="6" value="$opst[$i]"><br>\n);
			if($act eq "edit"){
				$tagline.="<input type=\"hidden\" name=\"ost${k}\" value=\"$opst[$i]\">\n";
			}
		}
	}
	print "</td>\n";
	print "</tr></table>\n";

}
elsif($option == 2){
	$c1=0;
	$c2=0;
	$n=@kigou1;
	if($n > $opnum){
		$sa=$n-$opnum;
		for($i=0;$i<$sa;$i++){
			pop @kigou1;
		}
	}
	elsif($n < $opnum){
		$sa=$opnum-$n;
		for($i=0;$i<$sa;$i++){
			push @kigou1,$kigou1[$i]
		}
	}
	$n=@kigou2;
	if($n > $opnum){
		$sa=$n-$opnum;
		for($i=0;$i<$sa;$i++){
			pop @kigou2;
		}
	}
	elsif($n < $opnum){
		$sa=$opnum-$n;
		for($i=0;$i<$sa;$i++){
			push @kigou2,$kigou2[$i]
		}
	}

	$j=1;
	print "[値]<br>\n";
	print "<table border=0><tr>\n";
	for($u=0;$u<$option;$u++){
		$t="op".$j;
		print "<td>\n";
		if($opnum > 0){
			for($i=0;$i<$opnum;$i++){
				$k=$i+1;
				print "$k: ";
				if($j==1){
					print $kigou1[$c1];
					$c1++;
					if($c1 > $#kigou1){
						$c1=0;
					}
				}
				elsif($j==2){
					print $kigou2[$c2];
					$c2++;
					if($c2 > $#kigou2){
						$c2=0;
					}
				}
				print qq(<input type="text" name="op${j}_value${k}" size="12" value="${$OPT{$t}}[$i]"><br>\n);
				if($act eq "edit"){
					$tagline.="<input type=\"hidden\" name=\"op${j}_value${k}\" value=\"${$OPT{$t}}[$i]\">\n";
				}
			}
		}
		print "</td>\n";
		$j++;
	}
	print "</tr>";
	print "</table>";
	print "<br><div>[在庫数]</div>";
	print "<table border=0>\n";
	$q=1;
	$c1=0;
	$c2=0;
	$g=0;
	$col=3;
	$m=$opnum;

	if($opnum < $col){
		$col=$opnum;
	}
	$k=0;
	for($j=1;$j<=$m;$j++){
		$w=150;

		if($q==1){
			print "<tr>\n";
		}
		print "<td valign=top width=$w>\n";

		for($i=0;$i<$opnum;$i++){
			$k++;
			if($k < 10){
				print "&nbsp;&nbsp;";
			}
			print "$k: ";
			print "$kigou1[$c1]-$kigou2[$c2]";
			$c2++;
			if($c2 > $#kigou2){
				$c2=0;
			}
			print qq(<input type="text" name="ost${k}" size="12" value="$opst[$g]"><br>\n);
			if($act eq "edit"){
				$tagline.="<input type=\"hidden\" name=\"ost${k}\" value=\"$opst[$g]\">\n";
			}
			$g++;
		}

		print "</td>\n";
		if($q==$col){
			print "</tr>\n";
			$q=0;
		}
		$q++;
		$c1++;
		if($c1 > $#kigou1){
			$c1=0;
		}
	}

	$q--;
	if($q && $q != $col){
		for($i=$j;$i<$col;$i++){
			print "<td> </td>\n";
		}
		print "</tr>\n";
	}
	print "</table>\n";


}

print <<EOM;
</td>
</tr>
<tr>
<td height="10"></td>
<td></td>
</tr>
<tr>
<td colspan="2" align="center">
<input type="submit" value="登録" style="width:150px"><input type="checkbox" name="tag" value="1" checked>タグ生成&nbsp;&nbsp;<input type="button" value="プレビュー" onclick="Preview();">
</td>
</tr>
</table>
</form>
	</div>
	<div id="right">
		<div id="tag">$tag</div>
	</div>
</div>
<form name="fomove_enter" action="$script" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="enter">
</form>
<script type="text/javascript">


</script>
</body>
</html>
EOM
exit;
}

sub enter{
my(@all,$num,$i);
my($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst);
my($st,@op,@opst,$j,@o,$v,$oline1,$oline2,@o1,@o2,$l,$t);

&header;

print <<EOM;
<body>
<div id="menu"><a href="javascript:void(0)" onclick="document.fomove_enter.submit();" class="navi">ログインに戻る</a></div>

<div id="form">
<form method="post" action="$script">
<input type="hidden" name="mode" value="form">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="submit" value="新規登録">
</form>
</div>

<p id="midasi">登録されている商品</p>
<div id="msg">
順番を変更するときは「順番」の下のフォームに半角数字を入力して「順番」をクリックしてくたさい。<br>
在庫の入力があり、在庫管理されているものについては、「在庫数」が表示されます。
</div>

<form name="editfo" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="edit">
<input type="hidden" name="editnum" value="">
</form>
<form name="delfo" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="del">
<input type="hidden" name="delnum" value="">
</form>

<form name="fo" method="POST" action="$script" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type="hidden" name="mode" value="position">

<table border="1" cellpadding="3" cellspacing="0" id="tb_list">
<tr>
<td align="center"><input type="submit" value="順番"></td><td align="center" width="100"><b>商品番号</b></td><td align="center" width="400"><b>商品名</b></td><td align="center" width="100"><b>在庫数</b></td><td align="center"><input type="button" value="削除" onclick="DelCheck()"></td><td align="center">&nbsp;</td>
</tr>
EOM


unless(open(FILE,$logfile)){
	&error("$logfileが開けません。");
}
@all=<FILE>;
close FILE;

$num=@all;

$i=0;
foreach(@all){
	($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst)=split(/,/,$_);
	$i++;
	$st="";
	if($stock ne ""){
		$st=$stock;
	}
	elsif($opst ne ""){
		if($op=~/\//){
			($dum,$op)=split(/\//,$op);
		}
		@op=split(/<>/,$op);
		@opst=split(/:/,$opst);
		if(@op == 1){
			@o=split(/:/,$op);
			$j=0;
			foreach $v(@o){
				$st.="$v:$opst[$j]<br>\n";
				$j++;
			}
		}
		elsif(@op == 2){
			@o=split(/<>/,$op);
			$oline1=$o[0];
			$oline2=$o[1];
			$oline1.=':d';
			$oline2.=':d';
			@o1=split(/:/,$oline1);
			@o2=split(/:/,$oline2);
			pop @o1;
			pop @o2;
			$j=0;
			foreach $l(@o1){
				foreach $v(@o2){
					$t="$l $v";
					if($opst[$j] ne ""){
						$st.="$t:$opst[$j]<br>\n";
					}
					$j++;
				}
			}
		}
	}


print <<EOM;
<tr>
<td align="center">
<input name="order_$i" size="4">
</td>
EOM

print <<EOM;
<td align="center">$no</td><td align="center">$name</td><td align="left">$st</td>
<td align="center">
<input type="checkbox" name="delnum" value="$no">
</td>
<td align="center">
<input type="button" value="編集" onclick="Edit('$no')">
</td>
EOM

}

close FILE;
print <<EOM;
</table>
</form>

<form name="fomove_enter" action="$script" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="$FORM{'pass'}">
</form>

</body>
</html>
EOM
exit;
}

sub regist{
my(@all,$no,$i,$t,$t2,$op,@op,$r,$opt,$opst,$tmp,$tag);


if($FORM{'no'} eq ""){
	&error("商品番号が記入されていません。");
}

&filelock;

unless(open(FILE,$logfile)){
	&error("$logfileが開けません。");
}
@all=<FILE>;
close FILE;

foreach(@all){
	($no)=split(/,/,$_);
	if($no eq $FORM{'no'}){
		&error("この商品番号はすでに使用されています。");
	}
}

for($i=1;$i<=$option;$i++){
	$t="op$i";
	$t2="o_name$i";
	if(@{$OPT{$t}}){
		$op=&optout($FORM{$t2},\@{$OPT{$t}});
	}
	else{
		$op="";
	}
	if($op){
		push @op,$op;
	}
}

$r=0;
$r=&echeck(\@op);
if($r){
	$opt=join("<>",@op);
}

$r=0;
$r=&echeck(\@OPST);
if($r){
	$opst=join(":",@OPST);
}

$tmp="$FORM{'no'},$FORM{'name'},$FORM{'price'},$FORM{'image'},$FORM{'postage'},$FORM{'weight'},$FORM{'pack'},$FORM{'page'},$FORM{'amount'},$FORM{'no_s'},$FORM{'no_w'},$FORM{'cool'},$FORM{'stock'},$opt,$opst,\n";

push @all,$tmp;

unless(open(FILE,">$logfile")){
	&error("$logfileが開けません。");
}
print FILE @all;
close FILE;

&makejs(\@all);

if($lockflag==1){
	close LOCK;
}

$FORM{'opst'}=$opst;
$FORM{'opt'}=$opt;


$tag=&maketag;


&form("","$FORM{'no'}を登録しました。",$tag);

}



sub echeck{
my $ref=$_[0];
my $flag=0;
foreach(@{$ref}){
	if($_ ne ""){
		$flag=1;
		last;
	}
}
return $flag;
}

sub optout{
my($o_name,$ref,$opflag,$optmp);

$o_name=$_[0];
$ref=$_[1];

$opflag=0;

foreach(@{$ref}){
	if($_ ne ""){
		$opflag=1;
		last;
	}
}
if($opflag){
	$optmp=join(":",@{$ref});
	if($o_name){
		$optmp=$o_name.'/'.$optmp;
	}

}

return($optmp);

}

sub del{
my(@delnum,$idx,$no,$flag,$n,@new);

@delnum=split(/:/,$FORM{'delnum'});

&filelock;

unless(open(FILE,$logfile)){
	&error("$logfileが開けません。");
}
$idx=0;
while(<FILE>){
	($no)=split(/,/,$_);
	$flag=0;
	foreach $n(@delnum){
		if($n eq $no){
			$flag=1;
			last;
		}
	}
	if(!$flag){
		$new[$idx++]=$_;
	}
}
close FILE;


unless(open(FILE,">$logfile")){
	&error("$logfileが開けません。");
}
print FILE @new;
close FILE;

&makejs(\@new);

if($lockflag==1){
	close LOCK;
}

&enter;

}



sub editregist{
my($i,$t,$t2,$op,@op,$r,$opt,$opst,$tmp,$idx,@new,$no,$tag);


&filelock;

unless(open(FILE,$logfile)){
	&error("$logfileが開けません。");
}

for($i=1;$i<=$option;$i++){
	$t="op$i";
	$t2="o_name$i";
	if(@{$OPT{$t}}){
		$op=&optout($FORM{$t2},\@{$OPT{$t}});
	}
	else{
		$op="";
	}
	if($op){
		push @op,$op;
	}
}

$r=0;
$r=&echeck(\@op);
if($r){
	$opt=join("<>",@op);
}

$r=0;
$r=&echeck(\@OPST);
if($r){
	$opst=join(":",@OPST);
}

$tmp="$FORM{'no'},$FORM{'name'},$FORM{'price'},$FORM{'image'},$FORM{'postage'},$FORM{'weight'},$FORM{'pack'},$FORM{'page'},$FORM{'amount'},$FORM{'no_s'},$FORM{'no_w'},$FORM{'cool'},$FORM{'stock'},$opt,$opst,\n";


$idx=0;
while(<FILE>){
	($no)=split(/,/,$_);
	if($no eq $FORM{'editnum'}){
		$_=$tmp;
	}
	$new[$idx]=$_;
	$idx++;
}
close FILE;

unless(open(FILE,">$logfile")){
	&error("${logfile}に書き込みできません。");
}
print FILE @new;
close FILE;

&makejs(\@new);

if($lockflag==1){
	close LOCK;
}

$tag=&maketag;


&form("","$FORM{'no'}を編集しました。",$tag);

}

sub makejs{
my($ref);
my($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst);
my($dum,@op,@opst,$tmp,$i,$v,@o,$oline1,$oline2,$l,$t);


$ref=$_[0];

unless(open(FILE,">$jslog")){
	&error("$jslogが開けません。");
}
print FILE "var st=new Array();\n";
foreach(@{$ref}){
	($no,$name,$price,$image,$postage,$weight,$pack,$page,$amount,$no_s,$no_w,$cool,$stock,$op,$opst)=split(/,/,$_);
	if($op ne "" || $opst ne ""){
		if($op=~/\//){
			($dum,$op)=split(/\//,$op);
		}
		@op=split(/<>/,$op);
		@opst=split(/:/,$opst);
		$tmp="";
		$tmp.="st['$no']=new Array()\;\n";
		$i=0;
		if(@op == 1){
			@o=split(/:/,$op);
			foreach $v(@o){
				$tmp.="st['$no']['$v']='$opst[$i]'\;\n";
				$i++;
			}
		}
		elsif(@op == 2){
			@o=split(/<>/,$op);
			$oline1=$o[0];
			$oline2=$o[1];
			$oline1.=':d';
			$oline2.=':d';
			@o1=split(/:/,$oline1);
			@o2=split(/:/,$oline2);
			pop @o1;
			pop @o2;
			$i=0;
			foreach $l(@o1){
				foreach $v(@o2){
					$t="$l $v";
					if($opst[$i] ne ""){
						$tmp.="st['$no']['$t']='$opst[$i]'\;\n";
					}
					$i++;

				}
			}
		}
	}
	else{
		$tmp="st['$no']='$stock'\;\n";
	}
	print FILE $tmp;
}

close FILE;


}



sub maketag{
my($skinline,$amax,$koline,$i,$opline,$t,$t2,$r,$oline,$op,@tmp,$image);


unless(open(HTML, $skin)){
	&error("$skinが開けません。ファイル名を確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);


if($FORM{'amount'}){
	$amax=$FORM{'amount'};
}
else{
	$amax=3;
}
$koline="";
for($i=0;$i<=$amax;$i++){
	$koline.="<option value=\"$i\">$i</option>";
	if($i != $amax){
		$koline.="\n";
	}
}

$opline="";
for($i=1;$i<=$option;$i++){
	$t="op$i";
	$t2="o_name$i";
	$r=&echeck(\@{$OPT{$t}});
	if($r){
		$oline=$FORM{$t2}."<select name=\"op$i\">\n";
		$op=&optout($FORM{$t2},\@{$OPT{$t}});
		if($op=~/\//){
			($dum,$op)=split(/\//,$op);
		}
		@tmp=split(/:/,$op);
		foreach(@tmp){
			$oline.="<option value=\"$_\">$_</option>\n";
		}
		$oline.="</select>";
		$opline.=$oline;
	}
}

if($FORM{'image'}){
	$image="<img src=\"$FORM{'image'}\">";
}

$skinline=~s/<!--image-->/$image/;
$skinline=~s/<!--number-->/$FORM{'no'}/;
$skinline=~s/<!--name-->/$FORM{'name'}/;

$skinline=~s/#name/$FORM{'name'}/;
$skinline=~s/#number/$FORM{'no'}/;
$skinline=~s/#price/$FORM{'price'}/;
$skinline=~s/#image/$FORM{'image'}/;
$skinline=~s/#weight/$FORM{'weight'}/;
$skinline=~s/#pack/$FORM{'pack'}/;
$skinline=~s/#postage/$FORM{'postage'}/;
$skinline=~s/#page/$FORM{'page'}/;
$skinline=~s/#stock/$FORM{'stock'}/;
$skinline=~s/<!--ko-->/$koline/;
$skinline=~s/<!--op-->/$opline/;

$skinline=~s/</&lt;/g;
$skinline=~s/>/&gt;/g;
$skinline=~s/"/&quot;/g;
$skinline=~s/\n/<br>\n/g;

return $skinline;


}

sub preview{
my($skinline,$amax,$koline,$i,$opline,$t,$t2,$r,$oline,$op,@tmp,$image,$dum);

if($FORM{'no'} eq ""){
	&error("商品番号が入力されていません。");
}
if($FORM{'name'} eq ""){
	&error("商品名が入力されていません。");
}


unless(open(HTML, $skin)){
	&error("$skinが開けません。ファイル名を確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);


if($FORM{'amount'}){
	$amax=$FORM{'amount'};
}
else{
	$amax=3;
}
$koline="";
for($i=0;$i<=$amax;$i++){
	$koline.="<option value=\"$i\">$i</option>\n";
}

$opline="";

for($i=1;$i<=$option;$i++){
	$t="op$i";
	$t2='o_name'.$i;
	$r=&echeck(\@{$OPT{$t}});
	if($r){
		$oline=$FORM{$t2}."<select name=\"op$i\">\n";
		$op=&optout($FORM{$t2},\@{$OPT{$t}});
		if($op=~/\//){
			($dum,$op)=split(/\//,$op);
		}
		@tmp=split(/:/,$op);
		foreach(@tmp){
			$oline.="<option value=\"$_\">$_</option>\n";
		}
		$oline.="</select>";
		$opline.=$oline;
	}
}
if($FORM{'image'}){
	$image="<img src=\"$FORM{'image'}\">";
}

$skinline=~s/<!--image-->/$image/;
$skinline=~s/<!--number-->/$FORM{'no'}/;
$skinline=~s/<!--name-->/$FORM{'name'}/;

$skinline=~s/#name/$FORM{'name'}/;
$skinline=~s/#number/$FORM{'no'}/;
$skinline=~s/#price/$FORM{'price'}/;
$skinline=~s/#image/$FORM{'image'}/;
$skinline=~s/#weight/$FORM{'weight'}/;
$skinline=~s/#pack/$FORM{'pack'}/;
$skinline=~s/#postage/$FORM{'postage'}/;
$skinline=~s/#page/$FORM{'page'}/;
$skinline=~s/#stock/$FORM{'stock'}/;

$skinline=~s/<!--ko-->/$koline/;
$skinline=~s/<!--op-->/$opline/;

print $skinline;


exit;

}


sub header{
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<title>管理画面</title>
<style type="text/css">
<!--
body{
	color:${t_color};
	background-color:${b_color};
}
p,td,div{
	font-size:${f_size};
}
a{
	color : ${l_color}
}

#tag{
	width: 400px;
	height: 500px;
	border-style: solid;
	border-color: #999999;
	border-width: 1px;
	margin-top: 50px;
	padding: 5px;
}

#login{
	width: 300px;
	margin: 100px auto 0 auto;
	text-align: center;
}

#tb_list{
	margin: 0 auto;
}

#midasi{
	width: 800px;
	margin: 0 auto;
	text-align: center;
	font-weight: bold;
	margin-bottom: 20px;
}

#midasi2{
	font-weight: bold;
}

#msg{
	width: 800px;
	margin: 0 auto;
	margin-bottom: 10px;
}

#form{
	text-align: center;
	margin-bottom: 20px;
	margin-top: 10px;
}

#menu{
	width: 800px;
	margin: 0 auto;
}

#menu2{
	width: 920px;
	margin: 0 auto;
}

#cont{
	width: 920px;
	display: flex;
	justify-content: flex-start;
	margin: 0 auto;
}

#left{
	width: 500px;
	margin-right: 20px;
}

#right{
	width: 400px;
}

-->
</style>
<script type="text/javascript">
function DelCheck(n){
	if(window.confirm("本当に削除しますか？")){
		var n;
		var ary=new Array();
		for(i=0;i<document.fo.elements.length;i++){
			n=document.fo.elements[i].name;
			if(n.indexOf("delnum") == 0){
				if(document.fo.elements[i].checked == true){
					ary.push(document.fo.elements[i].value);
				}
			}
		}
		var line=ary.join(":");

		document.delfo.delnum.value=line;
		document.delfo.submit();
	} 
	else{
		return false;
	}
}
function Edit(n){
	document.editfo.editnum.value=n;
	document.editfo.submit();
}


function Preview(){
	var tmp=document.fo.mode.value;
	document.fo.mode.value="preview";
	document.fo.target="preview";
	window.open("","preview","location=no,status=yes,toolbar=no,menubar=no,scrollbars=yes,resizable=yes,top=0,left=0,width=650,height=500");
	document.fo.submit();
	document.fo.mode.value=tmp;
	document.fo.target="";
}


</script>
</head>
EOM
}


sub filelock{
my($result,$i);
$lockflag = 0;
if(open(LOCK, ">$lockfile")){
	eval{$result=flock(LOCK,2);};
	if($@){&error("このサーバーはflockが使えないので、ロックはオフにしてください。");}
	if($result){
		$lockflag=1;
	}
	else{
		$lockflag=2;
		close LOCK;
	}
	$result=0;
}
else{
	&error("lockファイルがないか、パーミッションが書き込み可になっていません。");
}
if($lockflag == 2){
	&error("書き込みできませんでした。もう一度お試しください。");
}
}




sub error{

if($lockflag==1){
	close LOCK;
}


print <<EOM;
Content-type: text/html

<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">
<title></title>
<style type="text/css">
td,p,div{font-size:10pt}
a{color : ${l_color}}
</style>
<body>
<h3>ERROR</h3>
<p>
EOM

print"※$_[0]\n";

print <<EOM;
</p>
</body>
</html>
EOM
exit;
}

